#ifndef _KEYPAD_H_
#define _KEYPAD_H_

#ifdef CONFIG_SOM100ES
#ifdef __KERNEL__	
	
	#include <asm/gcfpld.h>
	#include <asm/mcfeport.h>
	
	/*
 *	Define /dev/ coding.
 */
	#define KEYPAD_MAJOR	GCFPLDMAJOR
	#define FIRSTKEYMINOR 5
	#define KEYMINORNUM 1
	
	#undef POLLING 1
	#define SLEEP_FRACTION 50
	#define REPEAT_DELAY	   SLEEP_FRACTION//in units of HZ/SLEEP_FRACTION
	
	#if (HZ/SLEEP_FRACTION)
	#define TIMEOUT  (HZ/SLEEP_FRACTION)
	#else
	#define TIMEOUT 1
	#endif
	
	#define KEYHELD 			   (!MCFEPORT_PINSTATE(3))
	
	inline unsigned short GETKEYPOS(void){
			return (Keypad_Read()&ROWCOLMASK);
	}
	#define ROW(pos) 			((~pos)&KEYROW)
	#define COLUMN(pos)	 	(pos>>4)
	
	
	#define KEYPAD_IRQ 						MCFINT_EPORT3
	#define KEYPAD_IRQ_INIT() 			MCFEPORT_SETUPIRQ(3,LEVEL_TRIG)
	#define KEYPAD_MASK_IRQ() 		MCFEPORT_MASK(3)
	#define  KEYPAD_UNMASK_IRQ() 	MCFEPORT_UNMASK(3)
#endif //#ifdef __KERNEL

	#define KEYPAD_ROWS			4
	#define KEYPAD_COLUMNS   6

#endif //#ifdef CONFIG_SOM100MAP

/**
 * IOCTL command numbers
 */
#define DRIVERCODE 'K'

#define SETKEYARRAY		_IOR(DRIVERCODE,0,char)
#define GETKEYARRAY 	_IOW(DRIVERCODE,1,char)

/**
 * Key representing "undefined" in the keypad matrix
 */
#define KEYPAD_UNDEFINED_CHAR		'x'

#endif //_KEYPAD_H_


