#ifndef _MODBUS_FUNCS_H_
#define _MODBUS_FUNCS_H_

//function codes
#define READ_COILS           1
#define READ_DISCRETE_INPUTS 2
#define READ_HOLDING_REGISTERS 3
#define READ_INPUT_REGISTERS 4
	#define RI_DATANUM_BYTES 1

#define WRITE_SINGLE_COIL    5
	#define ON_REQUEST   0xff00
	#define OFF_REQUEST  0

#define WRITE_SINGLE_REGISTER 6
	#define WRITE_SING_RES_SIZE   4

#define WRITE_MULTIPLE_COILS 15

#define WRITE_MULTIPLE_REGISTERS 0x10
        #define WRITEM_RESPONSE_BYTES 4
        #define WR_DATASTART 5

#define MASK_WRITE_REGISTER 0x16
	#define MASK_WRITE_SIZE 6

#define DIAGNOSTICS	8	
	//sub function codes
	#define RETURN_QUERY 0
	#define RESTART_COMM 1
	#define RETURN_DIAGN 2
	#define CH_ASCII_IND 3
	#define LISTEN_ONLY  4
	#define CLEAR_COUNT  0x0a 
	#define RETURN_BUSM  0x0b
	#define COMM_ERR_CNT 0x0c
	#define BUS_EXCP_CNT 0x0d
	#define SLV_MSG_CNT  0x0e
	#define SLV_NO_RESP  0x0f
	#define SLV_NAK_CNT  0x10
	#define SLV_BUSY_CNT 0x11
	#define RETRN_OVERRN 0x12
	#define CLEAR_OVERRN 0x14

#endif //_MODBUS_FUNCS_H_
