/**************************************************************************
*                                                                                         
*  egprtl.c - Demonstration program, rotates a bit through a port with configurable
*  speed                                        
*                                                                                         
*  (C) Copyright 2005, EMAC.Inc www.emacinc.com                                           
*      written by      NZG ngustavson@emacinc.com                                 
*                                                                         																		 
*   This program is free software; you can redistribute it and/or modify 				 
*   it under the terms of the GNU General Public License as published by  			 
*   the Free Software Foundation; either version 2 of the License, or    					 
*   (at your option) any later version.                                  												 
*                                                                        																			 
**************************************************************************/                                                                                 
#include <stddef.h>
#include <strings.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/egpio.h>
#include <asm/types.h>



#define ARGCHECK(num){if(argc<num){printf("invalid number of arguements\n");help();return -1;}}
#define OPENDEV(filed,dev){if((filed = open(dev, O_RDWR))<=0){printf("couldn't open %s\n",dev);return -1;}}


static int help(void)
{
const char *help_table = 
"************************************************************\n"
"egprtl					                       				 \n"                        						 	
"EMAC.Inc->NZG                                 				 \n"
""__DATE__"                                    				 \n"
"usage:                                    	   				 \n"   
"egprtl device msecond-delay (ticks)		   				 \n"	
"ex:										   				 \n"
"egprtl /dev/egpio2 250 					   				 \n"
"rotate a bit around port2 with a 250 ms delay indefinately	 \n"
"egprtl /dev/egpio2 750 10									 \n"
"rotate a bit around port2 with a 750 ms delay for ten shifts\n"
"************************************************************\n";
printf("%s",help_table);
return 0;
}

int main(int argc,char **argv)
{
int fd;
__u8 arg[1];
int command;
unsigned int delay;
unsigned int iter = -1;
unsigned int loop = 0;
__u8 pinstate = 1;
__u8 config = 0xff;

ARGCHECK(3);
OPENDEV(fd,argv[1]);

if(ioctl(fd,CONFIGWRITE,&config)<0){
  	printf("ioctl configuration error\n");
	close(fd);
	return 0;	
}
delay = strtoul(argv[2],NULL,0)*1000;

//printf("delay = %x\n",delay);

if(argc>3)
 iter = strtoul(argv[3],NULL,0);
	
while(loop++ <= iter){
	if(ioctl(fd,DATAWRITE,&pinstate)<0){
  		printf("ioctl data error\n");
		break;
	}
	//printf("DATAWRITE %x\n",pinstate);
  	pinstate<<=1;
  	if(!pinstate)
  		pinstate=1;
  	usleep(delay);	
}

close(fd);
return 0;
}
