/**************************************************************************
*                                                                                         
*  echoswitch.c - Demonstration, echos an input GPIO port to an output.                           
*                                                                                         
*  (C) Copyright 2006, EMAC.Inc www.emacinc.com                                                                           
*                                                                         																		 
*   This program is free software; you can redistribute it and/or modify 				 
*   it under the terms of the GNU General Public License as published by  			 
*   the Free Software Foundation; either version 2 of the License, or    					 
*   (at your option) any later version.                                  												 
*                                                                        																			 
**************************************************************************/                                                                                 
#include <stddef.h>
#include <strings.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/egpio.h>
#include <asm/types.h>

#define ARGCHECK(num){if(argc<num){printf("invalid number of arguements\n");help();return -1;}}
#define OPENDEV(filed,dev){if((filed = open(dev, O_RDWR))<=0){printf("couldn't open %s\n",dev);return -1;}}

static int help(void)
{
const char *help_table = 
"************************************************************\n"
"echoswitch					                  				 \n"                        						 	
"EMAC.Inc->NZG                                 				 \n"
""__DATE__"                                    				 \n"
"usage:                                    	   				 \n"   
"echoswitch devicein deviceout				   				 \n"	
"ex:										   				 \n"
"echoswitch /dev/egpio1 /dev/egpio2 						 \n"
"************************************************************\n";
printf("%s",help_table);
return 0;
}

int main(int argc,char **argv)
{
int fdin,fdout;
__u8 arg[1];
int command;
unsigned int delay;
unsigned int iter = -1;
unsigned int loop = 0;
__u8 pinstate = 1;
__u8 configin = 0;
__u8 configout = 0xff;
__u8 data;

ARGCHECK(3);
OPENDEV(fdin,argv[1]);
OPENDEV(fdout,argv[2]);

if(ioctl(fdin,CONFIGWRITE,&configin)<0){
  	printf("ioctl configuration error\n");
	close(fdin);close(fdout);
	return 0;	
}

if(ioctl(fdout,CONFIGWRITE,&configout)<0){
  	printf("ioctl configuration error\n");
	close(fdin);close(fdout);
	return 0;	
}

while(1){
	if(ioctl(fdin,DATAREAD,&data)<0){
  		printf("couldn't read data\n");
		close(fdin);close(fdout);
		return 0;	
	}
	
	//printf("read %x\n",data);
	
	
	if(ioctl(fdout,DATAWRITE,&data)<0){
  		printf("couldn't write data\n");
		close(fdin);close(fdout);
		return 0;	
	}
	
	//printf("wrote %x\n",data);
	
	
}

close(fdin);
close(fdout);
return 0;
}
