/**************************************************************************
*                                                                                         
*  getsamples.c - Program for reading AtoD data using the READALL ioctl call.
*  							Currently only tested for the LTC1290 character driver.                           
*                                                                                         
*  (C) Copyright 2005, EMAC.Inc www.emacinc.com                                           
*      written by              NZG ngustavson@emacinc.com                                 
*                                                                         																		 
*   This program is free software; you can redistribute it and/or modify 				 
*   it under the terms of the GNU General Public License as published by  			 
*   the Free Software Foundation; either version 2 of the License, or    					 
*   (at your option) any later version.                                  												 
*                                                                        																			 
**************************************************************************/                                                                                 
#include <stddef.h>
#include <strings.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <asm/types.h>

#define  CHARACTER_INTERFACE
#include <asm/ltc1290.h>

#define BUFFERSIZE 8

#define ARGCHECK(num){if(argc<num){printf("invalid number of arguements\n");help();return -1;}}
#define OPENDEV(filed,dev){if((filed = open(dev, O_RDWR))<=0){printf("couldn't open %s\n",dev);return -1;}}


static int help(void)
{
const char *help_table = 
"***********************************************\n"
"getsamples				                               				\n"                        						 	
"EMAC.Inc->NZG                                   				\n"
""__DATE__"                                 							\n"
"usage:                                    								\n"   
"getsamples device													\n"
"ex:																			\n"
"getsamples /dev/ltc1290										\n"
"***********************************************\n";
printf("%s",help_table);
return 0;
}

static inline print_channels(int channels, __u16 *buffer){
	int channel;
	for(channel=0;channel<channels;channel++){
		printf("%x\t",buffer[channel]);
	}
}

int main(int argc,char **argv){
int fd;
__u16 buffer[NUMCHANNELS];
int channels = NUMCHANNELS;

ARGCHECK(2);
OPENDEV(fd,argv[1]);

if(ioctl(fd,READALL,&buffer)<0){//perform the operation
  		printf("READALL ioctl error\n");
  		close(fd);
  		return 0;
  }

print_channels(channels, buffer);

close(fd);
return 0;

}

