#include <stddef.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <asm/mcf_qspi.h>
//#include "mcf_qspi.h"


#define TESTSTR "SPI LOOP"

#define ARGCHECK(num){if(argc!=num){printf("invalid number of arguements\n");help();return -1;}}

#define OPENDEV(filed,dev){if((filed = open(dev, O_RDWR))<=0){printf("couldn't open %s\n",dev);return -1;}}

static int help(void)
{
const char *help_table =
"**********************************************\n"
"*spiloop.c                                      \n"
"*Nathan Z. Gustavson                         \n"
"*EMAC.Inc                                   \n"
"*"__DATE__"                                 \n"   
"*usage:                                      \n"   
"*spiloop  device                             \n"
"*ex:                                         \n"
"*spiloop /dev/mcf_spi                           \n"
"*loops a string out the spi port and checks for reception      \n"
"**********************************************\n";
printf("%s",help_table);
return 0;
}

int main(int argc, char **argv){	
	int fd;			
	char *test = TESTSTR;
	char retbuf[QSPIBSZ];
	qspi_read_data readdata;
	
	ARGCHECK(2);
	OPENDEV(fd,argv[1]);		
	
	bzero(retbuf,sizeof(retbuf));
	
	readdata.buf = test;
	readdata.length = strlen(test)+1;
	
	ioctl(fd, QSPIIOCS_READDATA, &readdata);
	
	read(fd,retbuf,readdata.length);
	
	printf("wrote %s read %s\n",test,retbuf);
	
	close(fd);
	return 0;
	}
